<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG3</title>
	<link rel="stylesheet" href="style.css">
	<style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2019-20<br>
			Trabajo TG3 del grupo T8<br>
			Titulo: TG3. Implementar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Requisitos de los prototipos a implementar</a></li>
			<li><a href="#3">3. Criterios de comparacion de los prototipos</a></li>
			<li><a href="#4">4. Implementación del prototipo con tecnología A</a></li>
			<li><a href="#5">5. Implementación del prototipo con tecnología B</a></li>
			<li><a href="#6">6. Comparacion de los prototipos</a></li>
			<li><a href="#7">7. Conclusiones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Información general</h2>
			<h3>1.1 Autores</h3>
			<p>GRUPO T8
				<p>Daniel Martinez Algar</p>
				<p>Marina Muñoz Latienda</p>
				<p>César Ortega Nieto</p>
				<p>Sandra López Méndez</p>
				<p>Vicente García González</p>
			</p>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<a href="https://gitlab.com/dte2020/t8/tg3/">https://gitlab.com/dte2020/t8/tg3/</a>".</p>
			<h3>1.3 Burndown chart</h3>
			<img src="burndownTG3.jpg">
			<h3>1.4 Presentación del trabajo</h3>
			<a href="tg3.pptx">Presentación con diapositivas del trabajo TG3</a></p>			
		</section>

		</section>
		<section id="2">
		<h2>2. Requisitos de los prototipos a implementar</h2>
		<p>El objetivo del proyecto es comparar la implementación de dos prototipos OWASP ZAP y Vega, ya vistos en el trabajo anterior. El mundo se empezó a concienciar de la importancia de la seguridad informática en la década de los 90, cuando empezaron a aparecer los primeros virus informáticos y malware. Esto llevó a que poco a poco se empezaran a crear herramientas de seguridad cada vez más completas como las que vamos a utilizar nosotros.</p>
		<p>La forma de análisis será la siguiente: haremos ataques a diferentes páginas web para así poder detectar que vulnerabilidades tienen estas. Estas herramientas son muy útiles debido a que si tenemos una pagina web, la forma de poder saber como defenderse de ataque externos es saber atacar, para así poder corregir estas vulnerabilidades y evitar que nos ataquen. Por esto, las personas que desarrollan páginas web deben de hacer ataques para así probar los posibles fallos de seguridad que pueda haber.</p>
		<p>Debemos tener en cuenta que a día de hoy, es muy importante proteger estas vulnerabilidades, ya que como sabemos, los datos son un bien muy preciado y es uno de los principales objetivos de los atacantes. Por esta razón es muy importante tener una buena seguridad y preservar los datos, evitando que caigan en manos de gente inapropiada.</p>  
			<h3>2.1 Catálogo de requisitos</h3>
			<h4>Ahora mostraremos los requisitos funcionales</h4> 
			<table>
				<tr>
					<th>Req.</th>
					<th>Descripcion</th>
				</tr>
				<tr>
					<td>RF01 </td>
					<td>La herramienta debe ofrecer la función de escaneo automático </td>
				</tr>
				<tr>
					<td>RF02</td>
					<td>La herramienta permite de gestionar ajustes de seguridad SSL/TLS  </td>
				</tr>
				<tr>
					<td>RF03 </td>
					<td>La herramienta dispone de pruebas de inyeccion XSS </td>
				</tr>
				<tr>
					<td>RF04 </td>
					<td>La herramienta dispone de pruebas de inyección SQL </td>
				</tr>
				<tr>
					<td>RF05 </td>
					<td>La herramienta dispone de proxy de interceptación </td>
				</tr>
				<tr>
					<td>RF06 </td>
					<td>La herramienta permite la configuración de socket </td>
				</tr>
				<tr>
					<td>RF07 </td>
					<td>La herramienta muestra la medición de la gravedad de las alertas </td>
				</tr>
				<tr>
					<td>RF08 </td>
					<td>La herramienta explica las vulnerabilidades encontradas </td>
				</tr>
				<tr>
					<td>RF09 </td>
					<td>La herramienta ofrece soluciones para las vulnerabilidades encontradas </td>
				</tr>
				<tr>
					<td>RF10 </td>
					<td>La herramienta permite detener el escaneo en cualquier momento guardando el progreso </td>
				</tr>
				<tr>
					<td>RF11 </td>
					<td>La herramienta permite consultar el historial de páginas escaneadas en la misma sesión </td>
				</tr>
				<tr>
					<td>RF12 </td>
					<td>La herramienta muestra el código fuente de la página escaneada </td>
				</tr>
			</table>
			<p>Aclaraciones: </p>
			<p>RF01: Las dos herramientas realizan un escáner automático de las páginas que el usuario decide analizar. Se inserta la URL de la página y el software se encarga del análisis automáticamente. </p>
			<p>RF02: Las herramientas utilizan una prueba de fuzzing que consiste en proporcionar datos inválidos a las URL que se analizan y ver si estas son capaces de detectar esos datos erróneos. </p>
			<p>RF03: Vega analiza la configuración de seguridad TLS / SSL e identifica oportunidades para mejorar la seguridad de sus servidores TLS. OWASP ZAP permite descifrar de forma transparente las conexiones SSL. Cifra cada solicitud antes de enviarla al servidor y descifra cada respuesta que vuelve. </p>
			<p>RF04: OWASP ZAP cuenta con pruebas de inyección SQL que comprueban si es posible inyectar datos en la aplicación para que ejecute una consulta SQL controlada por el usuario en la base de datos. Vega cuenta con pruebas de inyección que encuentran una vulnerabilidad de inyección SQL si la aplicación utiliza la entrada del usuario para crear consultas SQL sin la validación de entrada adecuada. </p>
			<p>RF05: Se cuenta con opciones en las dos herramientas, del uso de diferentes proxys a la hora de realizar los análisis de las URL. </p>
			<p>RF06: EL usuario puede configurar el socket en el que se va a conectar la aplicación para obtener los datos proxy de los análisis. </p>
			<p>RF10: Es decir, si nosotros empezamos un escaneo, nosotros podremos parar el escaneo en cualquier momento, y como los problemas que van surgiendo van saliendo en el historial, podremos analizar aquellos que se han encontrado hasta el momento que se ha parado. </p>
			<p>RF11: Cuando nosotros escaneamos una página, si después del escaneo de esta, escaneamos otra segunda página. Tendremos un historial de aquellas paginas anteriores que hemos analizado en la sesión abierta. </p>
			<p>RF12: Cuando se está analizando una página, si hacemos click en las alertas que nos salen, nos muestra la parte de código fuente referida a esa alerta. </p>
			<h4>Ahora mostraremos los requisitos no funcionales</h4> 
				<table>
				<tr>
					<th>Req.</th>
					<th>Tipo</th>
					<th>Descripcion</th>
				</tr>
				<tr>
					<td>RNF01 </td>
					<td>Dependibilidad </td>
					<td>El tiempo para iniciar la herramienta no debe ser mayor a 1 minuto </td>
				</tr>
				<tr>
					<td>RNF02 </td>
					<td>Usabilidad </td>
					<td>Se pueden ajustar las ventanas de la aplicación según quiera el usuario </td>
				</tr>
				<tr>
					<td>RNF03 </td>
					<td>Usabilidad </td>
					<td>La herramienta dispone de una Instalación rápida guiada  </td>
				</tr>
				<tr>
					<td>RNF04 </td>
					<td>Usabilidad </td>
					<td>La herramienta cuenta con manual de ayuda y comunidad de red  </td>
				</tr>
				<tr>
					<td>RNF05 </td>
					<td>Usabilidad </td>
					<td>La herramienta tiene interfaces gráficas bien formadas </td>
				</tr>
				<tr>
					<td>RNF06 </td>
					<td>Producto  </td>
					<td>La herramienta no debe consumir más de 1 GB de RAM </td>
				</tr>
				<tr>
					<td>RNF07 </td>
					<td>Produto </td>
					<td>La aplicación no debe ocupar más de 200MB de tamaño</td>
				</tr>
				<tr>
					<td>RNF08 </td>
					<td>Producto </td>
					<td>La herramienta se puede usar en diferentes sistemas operativos </td>
				</tr>
				<tr>
					<td>RNF09 </td>
					<td>Producto </td>
					<td>La potencia que se necesita no es muy grande en ambos, podemos arrancarlos desde un pendrive con Linux </td>
			</table>

		</section>
		<section id="3">
			<h2>3. Criterios de comparacion de los prototipos</h2>

			<h3>3.1 Criterio 1: Tiempo de inicio de la herramienta </h3>
				<ul>
					<li>Nombre del criterio: Tiempo inicio herramienta.</li>
					<li>Descripcion: Tiempo que tarda la herramienta en iniciar.</li>
					<li>Tipo de valor: Numérico (segundos). .</li>
				</ul>
			<h3>3.2 Criterio 2: Tiempo de instalación.</h4>
				<ul>
					<li>Nombre del criterio: Tiempo de instalación.</li>
					<li>Descripcion: Tiempo que tarda la herramienta en instalarse.</li>
					<li>Tipo de valor: Numérico (segundos).</li>
				</ul>
			<h3>3.3 Criterio 3: Manual de ayuda y comunidad de la red.  .</h4>
				<ul>
					<li>Nombre del criterio: Manual de ayuda y comunidad de la red.</li>
					<li>Descripcion: Evalúa si la herramienta cuenta con un manual de ayuda y comunidad de la red.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.4 Criterio 4: Calidad de Interfaz Gráfica.</h4>
				<ul>
					<li>Nombre del criterio: Calidad de Interfaz Gráfica.</li>
					<li>Descripcion: Evalúa si la herramienta dispone de instalación rápida guiada.</li>
					<li>Tipo de valor: Texto libre (sencilla e intuitiva/ complicada o compleja).</li>
				</ul>
			<h3>3.5 Criterio 5: Consumo en Megas de RAM.</h4>
				<ul>
					<li>Nombre del criterio: Consumo en Megas de RAM.</li>
					<li>Descripcion: Evaluación del consumo de memoria en el ordenador. (No debe consumir más de 1GB de RAM).</li>
					<li>Tipo de valor: Numérico (Megas).</li>
				</ul>
			<h3>3.6 Criterio 6: Peso de herramienta (Megas).</h4>
				<ul>
					<li>Nombre del criterio: Peso de herramienta (Megas).</li>
					<li>Descripcion: Evalúa el tamaño de la herramienta.</li>
					<li>Tipo de valor: Numérico (megas).</li>
				</ul>
			<h3>3.7 Criterio 7: Compatibilidad en distintos Sistemas Operativos.</h4>
				<ul>
					<li>Nombre del criterio: Compatibilidad en Sistemas Operativos.</li>
					<li>Descripcion: Evaluación de la compatibilidad de la herramienta en distintos Sistemas Operativos.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.8 Criterio 8: Potencia de arranque.</h4>
				<ul>
					<li>Nombre del criterio: Potencia de arranque.</li>
					<li>Descripcion: Evaluación de la potencia que necesita la herramienta para su arranque.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.9 Criterio 9: Tiempo de escaneo automático.</h4>
				<ul>
					<li>Nombre del criterio: Tiempo de escaneo automático.</li>
					<li>Descripcion: Minutos invertidos en el escaneo automático que proporciona la herramienta.</li>
					<li>Tipo de valor: Numérico (minutos).</li>
				</ul>
			<h3>3.10 Criterio 10: Disposición de pruebas inyección XSS.</h4>
				<ul>
					<li>Nombre del criterio: Disposición de pruebas inyección XSS.</li>
					<li>Descripcion: Posibilidad de pruebas XSS basadas en pruebas de software, que implica proporcionar datos inválidos, inesperados o aleatorios a las entradas .</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.11 Criterio 11: Disposición de pruebas de inyección SQL.</h4>
				<ul>
					<li>Nombre del criterio: Disposición de pruebas de inyección SQL.</li>
					<li>Descripcion: Posibilidad de realización de pruebas de inyección SQL.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.12 Criterio 12: Posibilidad de configuración de socket.</h4>
				<ul>
					<li>Nombre del criterio: Posibilidad de configuración de socket.</li>
					<li>Descripcion: Funcionalidad de poder configurar el socket con valores a elección del usuario.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.13 Criterio 13: Permiso de consulta del historial.</h4>
				<ul>
					<li>Nombre del criterio: Permiso de consulta del historial.</li>
					<li>Descripcion: La herramienta permite consultar el historial de páginas escaneadas en la misma sesión.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.14 Criterio 14: Visualización del código fuente de la página escaneada.</h4>
				<ul>
					<li>Nombre del criterio: Visualización del código fuente de la página escaneada.</li>
					<li>Descripcion: La herramienta permite visualizar el código fuente de la página escaneada.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.15 Criterio 15: Permiso para detener el escaneo.</h4>
				<ul>
					<li>Nombre del criterio: Permiso para detener el escaneo.</li>
					<li>Descripcion: Permiso para detener el escaneo en cualquier momento guardando el progreso.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.16 Criterio 16: Ofrece soluciones para las vulnerabilidades encontradas.</h4>
				<ul>
					<li>Nombre del criterio: Ofrece soluciones para las vulnerabilidades encontradas.</li>
					<li>Descripcion: La herramienta ofrece al usuario soluciones para las vulnerabilidades encontradas.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.17 Criterio 17: Disposición de pruebas proxy de interceptación.</h4>
				<ul>
					<li>Nombre del criterio: Disposición de pruebas proxy de interceptación.</li>
					<li>Descripcion: Disposición de realización pruebas de seguridad con el objetivo de analizar el flujo de peticiones y respuestas HTTP que se establece entre el dispositivo del cliente y la aplicación web.</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>
			<h3>3.18 Criterio 18: Disposición de ajustes de seguridad SSL/TLS.</h4>
				<ul>
					<li>Nombre del criterio: Disposición de ajustes de seguridad SSL/TLS.</li>
					<li>Descripción: La herramienta disposición de pruebas SSL/TLS</li>
					<li>Tipo de valor: Booleano.</li>
				</ul>

																																																																																			
		</section>

		<section id="4">
			<h2>4. Implementación del prototipo con tecnología A</h2>

			<p>En la carpeta encontramos un manual de la herramienta OWASP ZAP. Dentro de este se explica como se instala la herramienta en Windows, además de como se instala una
				distribucción en Linux que cuenta ya con la herramienta. También encontramos en el manual, una explicación simple de como funciona la herramienta, así como diferentes pruebas
				gráficas del uso de esta en diferentes páginas web.
			</p>
			<a href="https://gitlab.com/dte2020/t8/tg3/-/tree/master/prototipo-A/">https://gitlab.com/dte2020/t8/tg3/-/tree/master/prototipo-A/</a>.
		</section>

		<section id="5">
			<h2>5. Implementación del prototipo con tecnología B</h2>
			<p>En la carpeta encontramos un manual de la herramienta Vega. Dentro de este se explica como se instala la herramienta 
				en windows y linux. También se analizarán varias páginas explicando lo que nos encontramos, así como la comparación 
				entre los análisis hechos.</p>
			<p>
				<a
					href="https://gitlab.com/dte2020/T8/tg3/-/tree/master/prototipo-B/">https://gitlab.com/dte2020/T8/tg3/-/tree/master/prototipo-B/</a>.
			</p>				
		</section>

		<section id="6">
			<h2>6. Comparacion de los prototipos</h2>
			
			<table>
				<tr>
					<th>Criterio</th>
					<th>Prototipo A</th>
					<th>Prototipo B</th>
					<th>Comentarios</th>

				</tr>
				<tr>
					<td>Tiempo de inicio de la herramienta.</td>
					<td>5-10 seg.</td>
					<td>20 seg.</td>
					<td>Dependiendo del disco duro.</td>
				</tr>
				<tr>
					<td>Tiempo de instalación.</td>
					<td>menos de 1 minuto</td>
					<td>menos de 1 minuto</td>
					<td>El tiempo de instalación de ambas herraientas es menor de un minuto.</td>
				</tr>
				<tr>
					<td>Manual de ayuda y comunidad de la red.</td>
					<td>Si</td>
					<td>Si</td>
					<td>Ambas herramientas cuentan con un manual de ayuda para consulta de dudas y otras consultas. </td>
				</tr>
				<tr>
					<td>Calidad de Interfaz Gráfica.</td>
					<td>Sencilla e intuitiva.</td>
					<td>Sencilla e intuitiva.</td>
					<td>El análisis resulta sencillo gracias a la interfaz clara que disponen ambas herramientas. </td>
				</tr>
				<tr>
					<td>Consumo en Megas de RAM.</td>
					<td>Con escaneo 900MB; sin escaneo 350MB</td>
					<td>Con escaneo 300-600MB; sin escaneo 180MB</td>
					<td>El consumo en Megas es mayor en la herramienta OWASP ZAP.  </td>
				</tr>
				<tr>
					<td>Peso de herramienta (Megas).</td>
					<td>113 MB</td>
					<td>30,7 MB</td>
					<td>El peso de la herramienta OWASP ZAP es cuatro veces mayor al peso de la herramienta Vega. </td>
				</tr>
				<tr>
					<td>Compatibilidad en distintos Sistemas Operativos.</td>
					<td>Si.</td>
					<td>Si.</td>
					<td>Los S.O probados compatibles en ambas herramientas son Windows y Linux. </td>
				</tr>
				<tr>
					<td>Tiempo de escaneo automático.</td>
					<td>Entre 15 seg. y 10 min.</td>
					<td>X seg. y 14 minutos.</td>
					<td>El tiempo de escaneo automátco varía dependiendo de la página que se quiera escanear. </td>
				</tr>
				<tr>
					<td>Disposición de pruebas inyección XSS.</td>
					<td>Si.</td>
					<td>Si.</td>
					<td>Ambas herramientas cuentan con posibilidad de ejecutar pruebas de inyección XSS. </td>
				</tr>
				<tr>
					<td>Disposición de pruebas de inyección SQL.</td>
					<td>Si.</td>
					<td>Si.</td>
					<td>Ambas herramientas cuentan con posibilidad de ejecutar pruebas de inyección SQL. </td>
				</tr>
				<tr>
					<td>Posibilidad de configuración de socket.</td>
					<td>Si.</td>
					<td>Si.</td>
					<td>Ambas herramientas tienen la posibilidad de configuración de socket. </td>
				</tr>
				<tr>
					<td>Permiso de consulta del historial.</td>
					<td>Si.</td>
					<td>Si.</td>
					<td>OWAP ZAP: si, siempre y cuando no se cierre la sesión. </td>
				</tr>
				<tr>
					<td>Visualización del código fuente de la página escaneada.</td>
					<td>Si.</td>
					<td>Si.</td>
					<td>Posibilidad de visualización del html de la página cuando se está realizando un análisis. </td>
				</tr>
				<tr>
					<td>Permiso para detener el escaneo.</td>
					<td>Si.</td>
					<td>Si.</td>
					<td>Ambas tienen posibilidad de detener el escaneo. </td>
				</tr>
				<tr>
					<td>Ofrece soluciones para las vulnerabilidades encontradas.</td>
					<td>Si.</td>
					<td>Si.</td>
					<td>OWASP ZAP: ofrece soluciones para cada una de las vulnerabilidades que encuentra. </td>
				</tr>
				<tr>
					<td>Disposición de pruebas proxy de interceptación.</td>
					<td>Si.</td>
					<td>Si.</td>
					<td>Ambas herramientas presentan pruebas de interceptación de proxy. </td>
				</tr>
				<tr>
					<td>Disposición de ajustes de seguridad SSL/TLS.</td>
					<td>Si.</td>
					<td>Si.</td>
					<td>Ambas pueden conseguir una transmisión de datos segura gracias a la disposición de estos ajustes. </td>
				</tr>

			</table>
		</section>

		<section id="7">
			<h2>7. Conclusiones</h2>
			<p>Tras haber usado ambas herramientas podemos decir que VEGA cuenta con una interfaz bastante intuitiva y sencilla, que podría cualquier persona con unos conocimientos medios de informática. En cuanto a funciones se refiere cuenta con las herramientas necesarias para hacer un análisis básico de cualquier dominio o página web. Sin embargo, para un análisis mas exhaustivo se requiere la configuración de ciertos módulos los cuales no son faciles de implementar. Su instalación en windows nos ha resultado bastante sencilla pero a la hora de llevarlo a cabo en linux hemos tenido ciertos problemas las versiones más nuevas. En cuanto a la comunidad de ayuda no es precisamente muy amplia en comparación con el resto de herramientas de este tipo.</p>
			<p>En cuanto a OWASP ZAP podemos mencionar que su interfaz tambien es intuitiva y nos ha resultado sencillo su uso para las funciones más sencillas, aunque para entrar mas en profundidad si se deben tener bastantes mas conocimientos de la herramienta. La instalación de OWASP ZAP en windows es practicamente igual a la de VEGA, y no resulta para nada laboriosa la misma. En comparación con VEGA su instalación en linux nos resultó más fácil porque el sssoo cuenta con la herramienta instalada ya por defecto. La comunidad de ayuda de OWASP ZAP está formada por mas personas por lo que sus respuestas son mas rápidas. </p>
			<p>Desde nuestrto punto de vista y tras haber usado ambas herramientas creemos que aunque ambas pueden cumplir con las expectativas necesarias para un análisis básico, si quisieramos profundizar más en nuestros diagnosticos la herramienta de OWASP ZAP nos proporcionaría mejores resultados ya que no está tan limitada y tiene mayor rendiemiento. Por lo tanto llegamos a la conclusión de que ambas cumplen con las expectativas y nos han permitido desarollar nuestro trabajo como esperábamos. </p>
		</section>

		<p>(Hay que cumplir la estructura basica indicada de secciones. Pero si se desea se pueden añadir otras
			secciones como anexos. Por ejemplo, alguna encuesta de opinion realizada sobre las tecnologías, etc.)</p>

	</main>

</body>

</html>